
/******** SOME POINTER ERROR IN 1.2****/ 
/******** HARDCODING THE ROM VALUE IN TWO FUNCTIONS ****/ 
/********PERFECT OUTPUT--- ON 24 APR 2013 1035hrs   ****/ 


#pragma config OSC = HS,OSCS = OFF
#pragma config PWRT = OFF
#pragma config WDT = OFF
#pragma config DEBUG = OFF,LVP = OFF ,STVR = OFF

#include <P18F452.h>                    // USING 12MHZ CLOCK
#include<stdio.h>
#include<string.h>

#define output       LATBbits.LATB7
#define output_pin   TRISBbits.TRISB7=0
#define output_low   LATBbits.LATB7=0
#define output_high  LATBbits.LATB7=1
#define input_pin    TRISBbits.TRISB7=1
#define OW_PIN       PORTBbits.RB7


typedef unsigned char bool;
typedef unsigned char uint8;


char str[80];
//unsigned char dat[2][8];={{0x93,0x00,0x08,0x00,0xc4,0x37,0x2d,0x10},{0xd8,0x00,0x08,0x00,0xc4,0x0f,0xef,0x10}};

void DS1820_DelaySw60us(void);
void DS1820_DelaySw240us(void);
void DS1820_DelaySwReset(void);
void  DS1820_DelayCro(uint8 val);

void DS1820_DelayUs(int val);
void DS1820_Reset(void);
void ReadTemp(int *tem, uint8 ds);
void ConvTemp(uint8 ds);
void DS1820(uint8 ds);
//void ReadDS1820ROM(void);
void DS1820_WriteByte(uint8 val_u8);
uint8 DS1820_ReadByte(void); 
void DispTemp(int *tem,uint8 ds);

void SerTx(unsigned char c);
void SerTxS(char* s);


bool input_func(void)
{
    TRISBbits.TRISB7 = 1;     
    return (PORTBbits.RB7);
}

void main()
{
int r;



        TXSTA = 0x20;  					     //  for asynchronous , tx enable settings
        SPBRG = 18;  						// for 12mhz baud rate.
        TXSTAbits.TXEN = 1;
	    RCSTAbits.SPEN = 1;

while(1)
{
for(r=0;r<10;r++)
DS1820_DelayUs(10000);
 
DS1820(1);
DS1820_DelayUs(10000);
DS1820(0);

for(r=0;r<10;r++)
DS1820_DelayUs(10000);
}


}
 
void DS1820(uint8 ds)
{

int r,tem[9];
uint8 n;

DS1820_Reset();
for(n=0;n<82;n++);  // remaining delay.........

 ConvTemp(ds);
 ReadTemp(&tem[0],ds);
 DS1820_DelayUs(10000);
 DispTemp(&tem[0],ds);
 DS1820_DelayUs(10000);


}



/****************************************************/

void DS1820_Reset()
{
int brs,rst,ars,aars;

brs=input_func();
output_pin;
output_low;
DS1820_DelaySwReset();
input_pin;
DS1820_DelaySw60us();
rst=PORTBbits.RB7;
ars = input_func();
DS1820_DelaySw240us();
aars = input_func();
sprintf(str, "   RESET = %1d %1d %1d %1d  ",brs,rst,ars,aars);  //
        SerTxS(str);

   
}

/****************************************************/

void ConvTemp(uint8 ds)
{
int n;
unsigned char dat[2][8]={{0x93,0x00,0x08,0x00,0xc4,0x37,0x2d,0x10},{0xd8,0x00,0x08,0x00,0xc4,0x0f,0xef,0x10}};
  
 
 output_pin;
 output_low;
 DS1820_DelaySwReset();
 DS1820_DelaySw60us();
 DS1820_DelaySw240us();
 input_pin;
 for(n=0;n<100;n++);  // remaining 410usec

  DS1820_WriteByte(0x55);  //  MATCH ROM COMMAND..

   for(n=7;n>=0;n--)    // 64- BIT ROM LSB FIRST
   {
    DS1820_WriteByte(dat[ds][n]);
   }
//DS1820_DelayUs(1);

 DS1820_WriteByte(0x44);   //  CONVTEMP  COMMAND
 while (DS1820_ReadByte()==0xFF);
 
}

/****************************************************/


void ReadTemp(int *tem, uint8 ds)
{ 
int n;
unsigned char dat[2][8]={{0x93,0x00,0x08,0x00,0xc4,0x37,0x2d,0x10},{0xd8,0x00,0x08,0x00,0xc4,0x0f,0xef,0x10}};
 
 output_pin;
 output_low;
 DS1820_DelaySwReset();
 DS1820_DelaySw60us();
 DS1820_DelaySw240us();
 input_pin;
 
for(n=0;n<100;n++);       // clear data
 
DS1820_WriteByte(0x55);  // MATCH ROM COMMAND..

for(n=7;n>=0;n--)        //
{
DS1820_WriteByte(dat[ds][n]); // MATCH ROM COMMAND.. LSB FIRST
}
 DS1820_WriteByte(0xBE);    // READ SCRATCH PAD

 for(n=0;n<8;n++) 
 {
 tem[n]= 0;     
 tem[n]=DS1820_ReadByte();
 }
output_pin;
 output_low;
 DS1820_DelaySwReset();
 DS1820_DelaySw60us();
 DS1820_DelaySw240us();
 input_pin;
 
}

/****************************************************/

void DispTemp(int *tem,uint8 ds)
{
unsigned char tp,tpd,msb,nsb,lsb;
unsigned char dat[2][8]={{0x93,0x00,0x08,0x00,0xc4,0x37,0x2d,0x10},{0xd8,0x00,0x08,0x00,0xc4,0x0f,0xef,0x10}};
 

SerTx(' ');
SerTx(' ');
SerTx('T');
SerTx(ds+0x30);
SerTx(' ');
SerTx('=');

if(tem[1]==0xff)
                {                     // FOR -VE TEMPERATURE
                tem[0]=~tem[0];      // 2'S COMPLEMENT
                tem[0]++;
                }
                else
                {
                     SerTx(' ');       //  GIVE  SPACE IF +VE TEMP
               
                }


                tp  = tem[0]/2;	   // MAKE TEMP VALUE HALF IN TP	
                                         
                tpd = (tem[0] &1) ? 5:0;   //COMPARE LSB, IF '1',
                                        //TPD = 5 AFTER DECIMAL, ELSE '0'
                
                if(tp<10)           // if temp less than 10 
                                    // just add the ascii and sertx                 
                {
                SerTx(' ');
                SerTx(' ');
                SerTx(0x30 + tp);
                }

                else             
                {
                if(tp<100)       // if temp is < 100 
                {
                lsb=tp%10;       // convert to decimal
                nsb=(tp/10)%10;   // msb nsb lsb
                msb=(tp/10)/10;
                if (msb!=0)
                SerTx(0x30 +msb);
                else    SerTx(' ');  // give space is msb=0
                if (nsb!=0)
                SerTx(0x30 +nsb);           // if nsb>0 print ascii
                SerTx(' ');
                SerTx(0x30 +lsb);          // print lsb

                }
                          // 'IF' INSIDE ELSE IS CLOSED
                else
                {             // when temp>100
                lsb=tp%10;
                nsb=(tp/10)%10;
                msb=(tp/10)/10;
                SerTx(0x30 +msb);
                SerTx(0x30 + nsb);
                SerTx(0x30 + lsb);
                }                       // 2ND IF CLOSED

                }                   //    1ST IF-ELSE CLOSED
                
                SerTx('.');           // print the decimal value  
                SerTx(0x30+tpd);  
                SerTx(' ');

}


/****************************************************/

void SerTx(unsigned char c)
{
	while(PIR1bits.TXIF == 0);  
	TXREG = c;                  // 1 inst
}

void SerTxS(char* s)
{
   int i;  
   for(i=0; i<strlen(s); i++)   
   SerTx(s[i]);                // 7 inst
   
}

void DS1820_DelayUs(int val)
{
int k;
for(k=0;k<val;k++); 
}



void DS1820_DelaySw60us(void)
{
int i;
for(i=0;i<12;i++);  
}


void DS1820_DelaySwReset(void)
{
int j;
for(j=0;j<96;j++);
}

void DS1820_DelaySw240us(void)
{
int k;
for(k=0;k<48;k++);
}

/*************************************/

void DS1820_WriteByte(uint8 val_u8)
{
char i,j,temp;
   
    
    for (i=0;i<8;i++)
    {
     output_pin;
     temp = val_u8 & 0x01;
     if (temp){
     OW_PIN=0;
     ; 
     input_pin;
     for(j=0;j<2;j++);
     for(j=0;j<3;j++);
              }

     else     {
               output_pin;
               OW_PIN=0;
               DS1820_DelayCro(1);
               for(j=0;j<1;j++);
               input_pin;
              }
     val_u8 = val_u8 >>1;
   
     }
}


/********************************/

uint8 DS1820_ReadByte(void)
{
unsigned char i,j;
   unsigned char data=0;
   
   for(j=0;j<8;j++)
   {

        output_low;
        output_pin;;
        for(i=0;i<1;i++);
        i=2;
        i=3;
        input_pin;
        i=5;
        i=6;
        i=7;
        data = (OW_PIN << j) | data;
        for(i=0;i<5;i++); 
               
   }
   
   return data;
}


void  DS1820_DelayCro(uint8 val)
{
   int i,j;
   for(i = 0; i < val; i++)
   for( j = 0; j < 3; j++);
} 





/****************Out Put***************
 
*************



   
*/

